<?php
/**
 * The licensing admin page
 *
 * @package   Caldera_Easy_Pods
 * @author    Josh Pollock <Josh@JoshPress.net>
 * @license   GPL-2.0+
 * @link      
 * @copyright 2015 CalderaWP
 */

$license 	= get_option( CEP_LICENSE_KEY_OPTION_NAME );
$status 	= get_option( CEP_LICENSE_STATUS_KEY_OPTION_NAME, false );
if ( false == $status || 'invalid' == $status ) {
	$type = __( 'Activation', 'easy-pods' );
	$action = __( 'Activate Code', 'easy-pods' );
}else{
	$type = __( 'Deactivation', 'easy-pods' );
	$action = __( 'Dectivate Code', 'easy-pods' );
}

$main_page = admin_url( 'admin.php?page=easy_pods' );
?>

<div class="wrap">
	<div class="easy-pods-main-headercaldera">
		<h2>
			<?php _e( 'Caldera Easy Pods', 'easy-pods' ); ?></span>
			<span><?php _e( 'Licensing' ); ?></span>
			<span><?php echo cep_license_submit_button( $status ); ?></span>
			<span><a href="<?php echo esc_url( $main_page ); ?>" class="add-new-h2" title="<?php esc_attr_e( 'Go Back To Main Easy Pods Page', 'easy-pods' );?>"><?php _e( 'Back To Main Easy Pods Page', 'easy-pods' ); ?></a></span>
		</h2>
	</h2>
</div>

<form method="post">
	<table class="form-table">
		<tbody>
			<tr valign="top">
				<th scope="row" valign="top">
					<?php _e('License Key'); ?>
				</th>
				<td>
					<input id="licence-code" name="<?php esc_attr_e( CEP_LICENSE_KEY_OPTION_NAME ); ?>" type="text" class="regular-text" value="<?php esc_attr_e( $license ); ?>" />
					<label class="description" for="edd_sample_license_key"><?php _e( 'Enter your license key', 'easy-pods'); ?></label>
				</td>
			</tr>
		</tbody>
	</table>
</form>

<div id="cep-license-response" style="display: none;">
	<div id="good" style="display: none">
		<?php printf( '%1s was successful.', $type ); ?>
		<div id="expiration">
			<?php _e( 'Your license will expire on: ', 'easy-pods' ); ?>
			<span id="expiration-date"></span>
		</div>
	</div>
	<div id="bad" style="display: none">
		<?php printf( '%1s was not successful.', $type ); ?>
		<span id="extra-bad-message"></span>
	</div>
</div>


<div class="clear"></div>
<script type="text/javascript">
	/**
	 * Adds the nonce, and license code values to the submission.
	 *
	 * @since 0.2.0
	 */
	function cep_license_before() {
		var code = jQuery( '#licence-code' ).val();
		var nonce = jQuery( '#cep_license_nonce' ).val();
		jQuery( '#code-submit' ).attr( 'data-code', code ).attr( 'data-cep_license_nonce', nonce );
	}

	/**
	 * On response from submission updates DOM
	 *
	 * @todo update the submit if status is now changed.
	 *
	 * @since 0.2.0
	 */
	function cep_license_cb( response ) {
		jQuery( '#cep-license-response' ).hide();
		var success = response.data.data.success;
		if ( success ) {
			jQuery( '#expiration-date' ).html( response.data.data.expires );
			jQuery( '#good' ).show();
		}else{
			jQuery( '#bad' ).show();
			if ( 'undefined' != response.data.data.message ) {
				jQuery( '#extra-bad-message' ).html( response.data.data.message );
			}
		}

		jQuery( '#cep-license-response' ).show();


	}

</script>
